﻿using Syncfusion.UI.Xaml.Controls.Input;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace DateSelector
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        Popup dropdownpopup;
        public MainPage()
        {
            this.InitializeComponent();      
        }

        /// <summary>
        /// Invoked when this page is about to be displayed in a Frame.
        /// </summary>
        /// <param name="e">Event data that describes how this page was reached.  The Parameter
        /// property is typically used to configure the page.</param>
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
        }

        public static IEnumerable<T> FindVisualChildrenOfType<T>(DependencyObject parent)
       where T : DependencyObject
        {
            List<T> foundChildren = new List<T>();

            int childCount = VisualTreeHelper.GetChildrenCount(parent);
            for (int i = 0; i < childCount; i++)
            {
                var child = VisualTreeHelper.GetChild(parent, i);

                T childType = child as T;
                if (childType == null)
                {
                    foreach (var other in FindVisualChildrenOfType<T>(child))
                        yield return other;
                }
                else
                {
                    yield return (T)child;
                }
            }
        }

        private void datePicker_Loaded(object sender, RoutedEventArgs e)
        {

            if (datePicker != null)
            {
                foreach (Popup popup in FindVisualChildrenOfType<Popup>(datePicker))
                {
                    if (popup!=null && popup.Name == "PART_DropDown")
                    {
                        dropdownpopup = popup;
                        dropdownpopup.Opened += dropdownpopup_Opened;
                    }
                }

            }
        }

        void dropdownpopup_Opened(object sender, object e)
        {
            SfDateSelector selector = (dropdownpopup.Child as Grid).Children[0] as SfDateSelector;
            if (selector != null)
            {
                foreach (Button button in FindVisualChildrenOfType<Button>(selector))
                {
                    if (button.Name == "PART_DoneButton")
                    {
                        button.Tapped += Done_Tapped;
                    }
                    else if (button.Name == "PART_CancelButton")
                    {
                        button.Tapped += Cancel_Tapped;
                    }
                }
            }
        }

        void Cancel_Tapped(object sender, TappedRoutedEventArgs e)
        {
            
        }

        void Done_Tapped(object sender, TappedRoutedEventArgs e)
        {
            
        }
    }
}
